/**
 * 
 */
package de.mpiwg.itgroup.annotations.restlet;

import org.apache.log4j.Logger;
import org.restlet.Context;
import org.restlet.Restlet;
import org.restlet.routing.Router;

/**
 * @author casties
 *
 */
public class AnnotatorRestlet extends BaseRestlet {

    public final String version = "AnnotationManagerN4J/Annotator 0.3.0";

    public static Logger logger = Logger.getLogger(AnnotatorRestlet.class);

    /**
     * @param context
     */
    public AnnotatorRestlet(Context context) {
        super(context);
        logger.debug("AnnotatorRestlet!");
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.restlet.Application#createInboundRoot()
     */
    @Override
    public Restlet createInboundRoot() {
        // this.authenticator = createAuthenticator();

        Router router = new Router(getContext());

        router.attach("/annotations", AnnotatorAnnotations.class);
        router.attach("/annotations/{id}", AnnotatorAnnotations.class);
        router.attach("/search", AnnotatorSearch.class);
        router.attach("/groups", AnnotatorGroups.class);
        router.attach("/tags", AnnotatorTags.class);
        router.attach("/tags/{id}", AnnotatorTags.class);
        router.attach("/tags/{id}/annotations", AnnotatorAnnotationsByTags.class);
        router.attach("/resources", AnnotatorResources.class);
        router.attach("/resources/{id}", AnnotatorResources.class);
        router.attach("/resources/{id}/annotations", AnnotatorAnnotationsByResources.class);
        router.attach("/", AnnotatorInfo.class);
        // authenticator.setNext(router);
        // return authenticator;

        return router;
    }

    /* (non-Javadoc)
     * @see de.mpiwg.itgroup.annotations.restlet.RestletImpl#getVersion()
     */
    @Override
    public String getVersion() {
        return version;
    }

}
